/*
 * @author clemens
 * @date 28.08.2008
 * @version $Id: ServeResourceExample.java,v 1.2 2008-09-02 15:36:38 clemens Exp $
 */
package com.gentics.portalnode.sdk;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;

import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.ResourceURL;

public class ServeResourceExample extends GenericPortlet {

    /* (non-Javadoc)
     * @see javax.portlet.GenericPortlet#doView(javax.portlet.RenderRequest, javax.portlet.RenderResponse)
     */
    protected void doView(RenderRequest request, RenderResponse response)
            throws PortletException, IOException {
        PrintWriter w = response.getWriter();
           
        ResourceURL resourceUrl = response.createResourceURL();
        resourceUrl.setResourceID("css");
        
        // print some text which will be unreadable as long as the css file has not been served properly
        // also there is a red warning place which will be hidden when styles are applied correctly, thus
        // ensuring the serveResource() call was successful
        w.println("<link rel=\"stylesheet\" type=\"text/css\" href=\"" + resourceUrl + "\" />");
        w.println("<div style=\"color: white;\"><span class=\"serveResourceTest\"><em>The funk was brought.</em><p>"
                        + "If you are able to read this text, the css file has been served properly by "
                        + "ServeResourceExample. serveResource(), thus "
                        + "making this text visible to you.</p></span></div>"
                        + "<div style=\"color: red;\"><span class=\"serveResourceTestBroken\">"
                        + "You are able to read this text? " 
                        + "Either you got stylesheets disabled, or the ServeResourceTest is broken, "
                        + "which is nearly impossible!</span></div>");

    }

    /* (non-Javadoc)
     * @see javax.portlet.GenericPortlet#serveResource(javax.portlet.ResourceRequest, javax.portlet.ResourceResponse)
     */
    public void serveResource(ResourceRequest request, ResourceResponse response)
            throws PortletException, IOException {
        // currently this simple example only knows how to serve "css"
        // feel free to extend this
        if ("css".equals(request.getResourceID())) {
            response.setContentType("text/css");
            InputStream resourceStream = getClass().getResourceAsStream("serveresource.css");
            OutputStream responseStream = response.getPortletOutputStream();
            copyStreams(resourceStream, responseStream);
        }
    }

    /**
     * Helper method to copy the data from the in stream into the out stream
     * @param in input stream
     * @param out output stream
     * @throws IOException
     */
    protected void copyStreams(InputStream in, OutputStream out) throws IOException {
        byte[] buffer = new byte[4096];
        int read = 0;
        while ((read = in.read(buffer)) > 0) {
            out.write(buffer, 0, read);
        }
    }
}
