/*
 * @author alexander
 * @date 26.08.2008
 * @version $Id: SimpleAjax.java,v 1.3 2008-10-02 14:52:34 norbert Exp $
 */
package com.gentics.portalnode.sdk;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.ResourceServingPortlet;

public class SimpleAjax extends GenericPortlet implements ResourceServingPortlet {

    protected void doView(RenderRequest request, RenderResponse response)
            throws PortletException, IOException {
        // Output a very simple form with a single text field and a submit button.
        // Use jQuery to override the "click" event for the button and
        // submit the value of the text field by using Ajax.
        // Output the response text.
        PrintWriter writer = response.getWriter();

        // it is important to prefix the used element id's with the namespace to make them unique in the portal page
        String nameSpace = response.getNamespace().replaceAll("\\.", "_");
        String textName = nameSpace + "_name";
        String submitName = nameSpace + "_submit";
        String outputName = nameSpace + "_output";

        writer.println("<form>");
        writer.println("  <input type=\"text\" id=\"" + textName + "\"></input>");
        writer.println("  <input type=\"submit\" id=\"" + submitName + "\"></input>");
        writer.println("</form>");
        writer.println("<span id=\"" + outputName + "\"></span>");
        writer.println("<script type=\"text/javascript\">");
        writer.println("  $(document).ready(function() {");
        writer.println("    $(\"#" + submitName + "\").click(function() {");
        writer.println("      var data = {\"name\" : $(\"#" + textName + "\").attr(\"value\")};");
        writer.println("      $.post(\"" + response.createResourceURL() + "\", data, function(data) {");
        writer.println("        $(\"#" + outputName + "\").html(data);");
        writer.println("      });");
        writer.println("      return false;");
        writer.println("    });");
        writer.println("  });");
        writer.println("</script>");
    }

    public void serveResource(ResourceRequest request, ResourceResponse response)
            throws PortletException, IOException {
        // get the submitted parameter from the request, append the current time
        // and return the data to the client
        String name = request.getParameter("name");
        response.getWriter().println("<u>Your input</u>: " + name + "<br/>");
        response.getWriter().println(
                "<u>Current server time</u>: "
                        + SimpleDateFormat.getTimeInstance(DateFormat.MEDIUM).format(
                                new Date(System.currentTimeMillis())));
    }

}
